%% COGENT required to run this code. Download available here: http://cogent.psyc.bbk.ac.uk/

function [exp] = experiment(sub)

%% config

config_display( 1, 3, [0 0 0], [1 1 1], 'Arial', 40, 4 ) ; %0 for window, 1 for full screen
config_keyboard;

%% variables

%rng shuffle; 2011 %modified from rng('shuffle') 2013, RLB 18/3/14
rand('state', sum(100*clock)) %2008?

exp.fname                   = sprintf('SARTexp_sub%02d.mat',sub);                     % Results filename
exp.rtrials                 = 52;  %number trials per run (from NI paper)
exp.ntrials                 = exp.rtrials*8; % 6 is taken from number of repetitions in run section (cant work out how to code it up here w/o overwriting variables when save)
exp.wdir                    = cd;
exp.stimdir                 = 'Stimuli';

%need to make sure that there are enough stim below for number of trials
%otherwise it will get mad (index exceeds matrix). If too many though it
%will leave blanks in the final output

%need 18 "O" per threat, and safe, 190 "=", =36, 380


exp.stim.trial          = fullfile('exp.wdir','exp.stimdir','exp.stim.fname'); %apostrophes added, RLB 18/3/14
exp.stim.input          = {'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'=';	'O';	'=';	'=';	'=';	'=';	'=';};
exp.stim.order          = char(exp.stim.input) %%needs to be as a char format for some reason.
exp.times.context       = 3000
exp.times.fix       = [2000; 2000; 2000]; %taken from frontiers - no jitter, but saves editing task structure
exp.times.stim          = 250; %taken from frontiers paper
countshock              = 1;


%% need to ask about shock here
%% variable is 'intensity'
sh_int  = input('Shock intensity? ');
if sh_int > 5
    sh_int = input('Over 5. Please reinter intensity to confirm: ');
end
intensity = sh_int


%% run

start_cogent;

%% main task

clearpict(1);                                                                   % Clear buffer 1
preparestring('Press space as fast as you can for =, DO NOT respond for O ', 1);                                            % Prepare string in buffer 1
drawpict (1);                                                                   % Present buffer 1
waitkeydown(inf,71);                                                            % Wait inf for keypress (space)
clearpict(1);                                                                   % Clear buffer 1

    

    clearpict(1,0,0,1);
    clearpict(2,0,0,1);
    colour(1)=0;
    colour(2)=0;
    colour(3)=1;
    preparestring('YOU ARE NOW SAFE FROM SHOCK',1);
    drawpict(1);
    wait(exp.times.context);
    clearpict(1,0,0,1);
    
for trial=1:exp.rtrials 
    
    blocktype=1; %1=safe
    TrialstructureSART;
    
end

    clearpict(1,1,0,0);
    clearpict(2,1,0,0);
        colour(1)=1;
    colour(2)=0;
    colour(3)=0;
    preparestring('!YOU ARE NOW AT RISK OF SHOCK!',1);
    drawpict(1);
    wait(exp.times.context);
    clearpict(1,1,0,0);    

for trial=exp.rtrials+1:(2*exp.rtrials)
    
    blocktype=2; %2=threat 
    TrialstructureSART;   
end


    clearpict(1,0,0,1);
    clearpict(2,0,0,1);
        colour(1)=0;
    colour(2)=0;
    colour(3)=1;
    preparestring('YOU ARE NOW SAFE FROM SHOCK',1);
    drawpict(1);
    wait(exp.times.context);
    clearpict(1,0,0,1);

for trial=(2*exp.rtrials)+1:(3*exp.rtrials) 
    
    blocktype=1;
    TrialstructureSART;
    
end
    clearpict(1,1,0,0);
    clearpict(2,1,0,0);
            colour(1)=1;
    colour(2)=0;
    colour(3)=0;
    preparestring('!YOU ARE NOW AT RISK OF SHOCK!',1);
    drawpict(1);
    wait(exp.times.context);
    clearpict(1,1,0,0);    

for trial=(3*exp.rtrials)+1:(4*exp.rtrials)
    
    blocktype=2;
    TrialstructureSART;
   
end

    clearpict(1,0,0,1);
    clearpict(2,0,0,1);
        colour(1)=0;
    colour(2)=0;
    colour(3)=1;
    preparestring('YOU ARE NOW SAFE FROM SHOCK',1);
    drawpict(1);
    wait(exp.times.context);
    clearpict(1,0,0,1);

for trial=(4*exp.rtrials)+1:(5*exp.rtrials)
    
    blocktype=1;
    TrialstructureSART;
    
end

    clearpict(1,1,0,0);
    clearpict(2,1,0,0);
            colour(1)=1;
    colour(2)=0;
    colour(3)=0;
    preparestring('!YOU ARE NOW AT RISK OF SHOCK!',1);
    drawpict(1);
    wait(exp.times.context);
    clearpict(1,1,0,0);    
    
for trial=(5*exp.rtrials)+1:(6*exp.rtrials)
    
    blocktype=2;
    TrialstructureSART;
   
end

    clearpict(1,0,0,1);
    clearpict(2,0,0,1);
        colour(1)=0;
    colour(2)=0;
    colour(3)=1;
    preparestring('YOU ARE NOW SAFE FROM SHOCK',1);
    drawpict(1);
    wait(exp.times.context);
    clearpict(1,0,0,1);

for trial=(6*exp.rtrials)+1:(7*exp.rtrials)
    
    blocktype=1;
    TrialstructureSART;
    
end

    clearpict(1,1,0,0);
    clearpict(2,1,0,0);
            colour(1)=1;
    colour(2)=0;
    colour(3)=0;
    preparestring('!YOU ARE NOW AT RISK OF SHOCK!',1);
    drawpict(1);
    wait(exp.times.context);
    clearpict(1,1,0,0);    
    
for trial=(7*exp.rtrials)+1:(8*exp.rtrials)
    
    blocktype=2;
    TrialstructureSART;
    
   
end
    


%% save
clearpict(1);                               % Clear buffer 1
preparestring('End of Experiment', 1);      % Prepare string in buffer 1
drawpict (1);                               % Present buffer 1
waitkeydown(inf,71);                        % Wait inf for keypress (space)
clearpict(1);                              	% Clear buffer 1

exp.res.FLIPstime       =            exp.res.stime(:)    ;                %convert to columns
exp.res.FLIPface        =            exp.res.face(:)      ;  
exp.res.FLIPblock       =            exp.res.block(:) ; 
exp.res.FLIPkey         =            exp.res.key(:);
exp.res.FLIPkeytime     =            exp.res.keytime(:);
exp.res.FLIPRT         =             exp.res.RT(:);
exp.res.intensity      =             intensity;


save(exp.fname,'exp');                      % Save results file

stop_cogent;                                % Stop Cogent


